/*    Map script for jm_virtual    */
/* Map and script by <MasterThomy> */

#include maps\mp\jm_virtual_global;

main()
{	
	thread init();
	thread lavas();
	thread part0_door1();
	thread part0_door2();
	thread part2_cardrotates();
	thread part2_card1trig();
	thread part2_card1flip();
	thread part2_card2trig();
	thread part2_card2laser();
	thread part2_card3trig();
	thread part3_lifts();
	thread part3_musicchange();
	thread part4_spinners();
	thread part4_accenter();
	thread part4_accelerator();
	thread part4_accexit();
	thread part5_blocks();
	thread part5_scubatrig();
	thread part5_gate1trig();
	thread part5_gate2trig();
	thread part5_sinkers();
	thread part6_ladders1();
	thread part6_ladders2();
	thread part6_ladders3();
	thread part6_ladders4();
	thread part7_platforms();
	thread part7_spinners();
	thread part7_booktrig();
	thread part8_lasers();
	thread part8_hack();
	thread part9_boss();
	thread part9_lasers();
	thread bonus_musictrig();
	thread bonus_restart();
	thread bonus_endlessfun();
	thread part6_spinners();
	thread part8_gems();
	thread part8_lift();
}

lavas()
{
	lava=getent("lava","targetname");
	for(;;)
	{
		lava movez(6,1.5,.5,.5);
		wait 1.5;
		lava movez(-6,1.5,.5,.5);
		wait 1.5;
	}
}

part0_door1()
{
	p0_door11 = getent("p0_door11","targetname");
	p0_door12 = getent("p0_door12","targetname");
	p0_door1trig = getent("p0_door1trig","targetname");
	p0_door1s = getent("p0_door1s","targetname");
	door1o=p0_door11.origin;
	door2o=p0_door12.origin;
	for(;;)
	{ 
		p0_door1trig waittill("trigger",user);
		p0_door1s playsound("sss");
		p0_door11 moveto (door1o+(-60,0,0),1);
		p0_door12 moveto (door2o+(60,0,0),1);
		wait 3;
		p0_door1s playsound("sss");
		p0_door11 moveto (door1o,1);
		p0_door12 moveto (door2o,1);
	} 
}

part0_door2()
{
	p0_door2trig = getent("p0_door2trig","targetname");
	p0_door2 = getent("p0_door2","targetname");
	p0_door2m = getent("p0_door2m","targetname");
	p0_door2m hide();
	for(;;)
	{ 
		p0_door2trig waittill("trigger",user);
		user playlocalsound("putin");
		p0_door2m show();
		user playlocalsound("apocalipse");
		p0_door2 movey(-2,0.25);
		wait .3;
		p0_door2 movez(93,1.5);
		user iprintln(user.name + "^7: ^3Now we see what's in here!");
		p0_door2 waittill("movedone");
		wait 3;
		p0_door2m hide();
		p0_door2 movez(-93,1.5);
		p0_door2 waittill("movedone");
		p0_door2 movey(2,0.25);
		wait .3;
	}
}

part2_cardrotates()
{
	p2_card1m = getent("p2_card1m","targetname");	
	p2_card2m = getent("p2_card2m","targetname");
	p2_card3m = getent("p2_card3m","targetname");
	p2_card1m rotateyaw(7200000,40000);
	p2_card2m rotateyaw(7200000,40000);
	p2_card3m rotateyaw(7200000,40000);
	for(;;)
	{
		p2_card1m movez(4,1.5,.5,.5);
		p2_card2m movez(4,1.5,.5,.5);
		p2_card3m movez(4,1.5,.5,.5);
		wait 1.5;
		p2_card1m movez(-4,1.5,.5,.5);
		p2_card2m movez(-4,1.5,.5,.5);
		p2_card3m movez(-4,1.5,.5,.5);
		wait 1.5;
	}
}

part2_card1flip()
{
	p2_card1flipper = getent("p2_card1flipper","targetname");
	for(;;)
	{ 
		wait .05;
		p2_card1flipper waittill("trigger",user);
		if(user getplayerangles()[2]!=0) continue;
		user playlocalsound("apocalipse");
		user setplayerangles((0,user.angles[1],180));
		user iprintln(user.name + "^7: ^3Well, this is just weird...");
	}
}

part2_card1trig()
{
	p2_card1m = getent("p2_card1m","targetname");
	p2_card1trig = getent("p2_card1trig","targetname");
	for(;;)
	{ 
		wait .05;
		p2_card1trig waittill("trigger",user);
		if(user.card1_tmp || user.card1) continue;
		if(user getplayerangles()[2]==0) {user suicide();user iprintlnbold("^3Don't cheat!!!");continue;}
		user playlocalsound("pickup");
		p2_card1m hide();
		user.card1_tmp=true;
		user iprintlnbold("^3Obtained blue card!");
		wait 8;
		p2_card1m show();
	} 
}

part2_card2trig()
{
	p2_card2m = getent("p2_card2m","targetname");
	p2_card2trig = getent("p2_card2trig","targetname");
	for(;;)
	{ 
		wait .05;
		p2_card2trig waittill("trigger",user);
		if(user.card2_tmp || user.card2) continue;
		user playlocalsound("pickup");
		p2_card2m hide();
		user.card2_tmp=true;
		user iprintlnbold("^3Obtained green card!");
		wait 8;
		p2_card2m show();
	} 
}

part2_card2laser()
{
	p2_card2_laser = getent("p2_card2_laser","targetname");
	o=p2_card2_laser.origin;
	for(;;)
	{ 
		p2_card2_laser movex(1700,4);
		wait 4;
		p2_card2_laser movez(128,.75);
		wait .8;
		p2_card2_laser movex(-1700,4);
		wait 4;
		p2_card2_laser moveto(o,.75);
		wait .8;
	} 
}


part2_card3trig()
{
	p2_card3m = getent("p2_card3m","targetname");
	p2_card3trig = getent("p2_card3trig","targetname");
	for(;;)
	{ 
		wait .05;
		p2_card3trig waittill("trigger",user);
		if(user.card3_tmp || user.card3) continue;
		user playlocalsound("pickup");
		p2_card3m hide();
		user.card3_tmp=true;
		user iprintlnbold("^3Obtained red card!");
		wait 8;
		p2_card3m show();
	}
}

part3_lifts()
{
	for(i=1;i<=4;i++) 
	{
		getent("p3_lift"+i,"targetname") thread part3_lift();
		wait 9.5;
	}
}

part3_lift()
{
	self movez(120,.1);
	wait 1;
	o=self.origin;
	for(;;)
	{
		self movey(308,1);
		wait 4.5;
		self movey(4000,12);
		wait 12.2;
		self movey(2450,7);
		wait 7.2;
		self movey(13042,13,0.5,1);
		wait 13.2;
		self movez(-256,1);
		wait 1.1;
		self movey(-19800,.1);
		wait 0.2;
		self moveto(o,.5);
		wait .6;
	}
}

part3_musicchange()
{
	p3_musicchange = getent("p3_musicchange","targetname");
	for(;;)
	{ 
		p3_musicchange waittill("trigger",user);
		user thread music(0);
		wait 1;
	}
}

part4_spinners()
{
	getent("p4_spin1","targetname") rotateyaw(7200000,40000);
	getent("p4_spin2","targetname") rotateyaw(7200000,40000);
	getent("p4_spin3","targetname") rotateyaw(7200000,40000);
	getent("p4_spin4","targetname") rotateyaw(7200000,40000);
}

part4_accenter()
{
	p4_accelentertrig=getent("p4_accelentertrig","targetname");
	p4_accelenterorigin=getent("p4_accelenterorigin","targetname");
	for(;;)
	{
		p4_accelentertrig waittill("trigger",user);
		user setorigin(p4_accelenterorigin.origin);
		user.accel=true;
		wait .1;
	}
}

part4_accelerator()
{
	p4_accelerator=getent("p4_accelerator","targetname");
	p4_accelenterorigin=getent("p4_accelenterorigin","targetname");
	for(;;)
	{
		p4_accelerator waittill("trigger",user);
		if(isdefined(user.accel)) user setorigin(p4_accelenterorigin.origin);
	}
}

part4_accexit()
{
	p4_accelexittrig=getent("p4_accelexittrig","targetname");
	p4_accelexitorigin=getent("p4_accelexitorigin","targetname");
	for(;;)
	{
		p4_accelexittrig waittill("trigger",user);
		user.accel=undefined;
		user playlocalsound("teleport");
		user setorigin(p4_accelexitorigin.origin);
		wait .1;
	}
}

part5_blocks()
{
	blocks=[];
	for(i=0;i<5;i++) 
	{
		blocks[i]=[];
		for(j=0;j<3;j++) 
		{
			blocks[i][j]=getent("p5_b"+(i+1)+(j+1),"targetname");
			if(j==0 && (i==0 || i==4)) continue;
			blocks[i][j] hide();
			blocks[i][j] notsolid();
		}
	}
	
	for(;;)
	{			
		blocks[0][1] show();blocks[0][1] solid();
		blocks[3][2] show();blocks[3][2] solid();
		wait 0.2;
		blocks[4][1] hide();blocks[4][1] notsolid();
		blocks[4][2] hide();blocks[4][2] notsolid();
		wait 1;
		blocks[1][0] show();blocks[1][0] solid();
		blocks[2][2] show();blocks[2][2] solid();
		wait 0.2;
		blocks[0][1] hide();blocks[0][1] notsolid();
		blocks[3][2] hide();blocks[3][2] notsolid();
		wait 1;
		blocks[2][0] show();blocks[2][0] solid();
		blocks[1][2] show();blocks[1][2] solid();
		wait 0.2;
		blocks[1][0] hide();blocks[1][0] notsolid();
		blocks[2][2] hide();blocks[2][2] notsolid();
		wait 1;
		blocks[2][1] show();blocks[2][1] solid();
		blocks[0][2] show();blocks[0][2] solid();		
		wait 0.2;
		blocks[2][0] hide();blocks[2][0] notsolid();
		blocks[1][2] hide();blocks[1][2] notsolid();		
		wait 1;
		blocks[2][2] show();blocks[2][2] solid();	
		wait 0.2;
		blocks[2][1] hide();blocks[2][1] notsolid();
		blocks[0][2] hide();blocks[0][2] notsolid();
		wait 1;
		blocks[1][2] show();blocks[1][2] solid();
		wait 0.2;
		blocks[2][2] hide();blocks[2][2] notsolid();	
		wait 1;
		blocks[1][1] show();blocks[1][1] solid();
		wait 0.2;
		blocks[1][2] hide();blocks[1][2] notsolid();
		wait 1;
		blocks[2][1] show();blocks[2][1] solid();
		wait 0.2;
		blocks[1][1] hide();blocks[1][1] notsolid();
		wait 1;
		blocks[3][2] show();blocks[3][2] solid();
		wait 0.2;
		blocks[2][1] hide();blocks[2][1] notsolid();
		wait 1;
		blocks[3][1] show();blocks[3][1] solid();
		wait 0.2;
		blocks[3][2] hide();blocks[3][2] notsolid();
		wait 1;
		blocks[2][0] show();blocks[2][0] solid();
		wait 0.2;
		blocks[3][1] hide();blocks[3][1] notsolid();
		wait 1;
		blocks[3][0] show();blocks[3][0] solid();
		wait 0.2;
		blocks[2][0] hide();blocks[2][0] notsolid();
		wait 1;
		blocks[4][1] show();blocks[4][1] solid();
		blocks[4][2] show();blocks[4][2] solid();
		wait 0.2;
		blocks[3][0] hide();blocks[3][0] notsolid();
		wait 1;		
	}
}

part5_scubatrig()
{
	p5_scubam = getent("p5_scubam","targetname");
	p5_scubatrig = getent("p5_scubatrig","targetname");
	for(;;)
	{ 
		wait .05;
		p5_scubatrig waittill("trigger",user);
		if(user.scuba_tmp || user.scuba) continue;
		user playlocalsound("pickup");
		p5_scubam hide();
		user.scuba_tmp=true;
		user iprintlnbold("^3Obtained scuba gear!");
		wait 8;
		p5_scubam show();
	} 
}

part5_gate1trig()
{
	p5_gate1trig=getent("p5_gate1trig","targetname");
	p5_gate1water=getent("p5_gate1water","targetname");
	p5_gate1door1=getent("p5_gate1door1","targetname");
	p5_gate1door2=getent("p5_gate1door2","targetname");
	p5_gate1door1 movez(128,.1);
	p5_gate1water movez(-128,.1);
	for(;;)
	{
		p5_gate1trig waittill("trigger",user);
		if(!user.scuba && !user.scuba_tmp) {user iprintln(user.name + "^7:^3I think I'll need something to survive underwater!");continue;}
		user linkto(p5_gate1door2);
		p5_gate1door1 movez(-128,1);
		p5_gate1door1 waittill("movedone");
		user unlink();
		p5_gate1water movez(128,.5);
		p5_gate1door2 movez(128,.5);
		wait .5;
		players=getentarray("player","classname");
		for(i=0;i<players.size;i++) if(players[i]!=user && players[i] istouching(p5_gate1water)) {players[i] iprintlnbold("^3Don't cheat!!!");players[i] suicide();}
		user thread music(5);
		user thread part5_drown();		
		wait 3;
		p5_gate1door2 movez(-128,1);
		p5_gate1door2 waittill("movedone");
		p5_gate1water movez(-128,1);
		wait 1;
		p5_gate1door1 movez(128,.5);
		wait .5;
	}
}

part5_gate2trig()
{
	p5_gate2trig=getent("p5_gate2trig","targetname");
	p5_gate2water=getent("p5_gate2water","targetname");
	p5_gate2door1=getent("p5_gate2door1","targetname");
	p5_gate2door2=getent("p5_gate2door2","targetname");
	p5_gate2door2 movez(128,.1);
	for(;;)
	{
		p5_gate2trig waittill("trigger",user);
		user linkto(p5_gate2door1);
		p5_gate2door2 movez(-128,1);
		p5_gate2door2 waittill("movedone");
		user unlink();
		p5_gate2water movez(-118,1);
		wait .5;
		if(isdefined(user.oxygentext)) user.oxygentext destroy();
		if(isdefined(user.oxygentimer)) user.oxygentimer destroy();
		user notify("virtual_nodrown");
		user thread music(0);
		wait .5;
		p5_gate2door1 movez(128,.5);
		wait 1.5;
		p5_gate2door1 movez(-128,1);
		p5_gate2door1 waittill("movedone");
		p5_gate2water movez(118,.5);
		p5_gate2door2 movez(128,.5);
		wait .5;
	}
}

part5_sinkers()
{
	p5_sinkers=getentarray("p5_sinker","targetname");
	for(i=0;i<p5_sinkers.size;i++) thread part5_sinkerloop(p5_sinkers[i],int(p5_sinkers[i].script_noteworthy));
}

part5_sinkerloop(sinker,speed)
{
	o=sinker.origin;
	for(;;)
	{
		players=getentarray("player","classname");
		for(i=0;i<players.size;i++) if(players[i] istouching(sinker))
		{
			if(sinker.origin[2]>o[2]-120) sinker movez(speed*(-0.5),0.5);
			break;
		}
		if(i==players.size)
		{
				sinker moveto(o,0.5);
				wait .05;
		}
		wait .5;
	}
}

part6_ladders1()
{
	p6_ladder1=getent("p6_ladder1","targetname");
	p6_ladder2=getent("p6_ladder2","targetname");
	p6_ladder2 movex(-320,.1);
	wait .2;
	for(;;)
	{
		p6_ladder1 movex(-320,2);
		p6_ladder2 movex(320,2);
		wait 3;
		p6_ladder1 movex(320,2);
		p6_ladder2 movex(-320,2);
		wait 3;
	}
}

part6_ladders2()
{
	p6_ladder3=getent("p6_ladder3","targetname");
	p6_laser=getent("p6_laser","targetname");
	p6_ladder3 movez(192,.1);
	p6_laser movez(192,.1);
	wait .2;
	for(;;)
	{
		p6_ladder3 movez(-384,4);
		p6_laser movez(-384,4);
		wait 4.5;
		p6_ladder3 movez(384,4);
		p6_laser movez(384,4);
		wait 4.5;
	}
}

part6_ladders3()
{
	p6_ladder4=getent("p6_ladder4","targetname");
	p6_ladder5=getent("p6_ladder5","targetname");
	for(;;)
	{
		p6_ladder4 movey(448,2);
		p6_ladder5 movey(704,2.75);
		wait 3;
		p6_ladder4 movey(-448,2);
		p6_ladder5 movey(-704,2.75);
		wait 3;
	}
}
	
part6_ladders4()
{	
	p6_ladder6=getent("p6_ladder6","targetname");
	for(;;)
	{
		p6_ladder6 movex(-768,10);
		wait 11;
		p6_ladder6 movex(768,1);
		wait 2;
	}
}

part7_platforms()
{
	p7_platform1=getent("p7_platform1","targetname");
	p7_platform2=getent("p7_platform2","targetname");
	p7_platform3=getent("p7_platform3","targetname");
	p7_platform4=getent("p7_platform4","targetname");
	p7_platform5=getent("p7_platform5","targetname");
	p7_platform1 movey(-184,.1);
	p7_platform2 movey(-184,.1);
	p7_platform3 movey(-184,.1);
	wait .15;
	for(;;)
	{
		p7_platform1 movey(184,1.5);
		p7_platform4 movey(-184,1.5);
		wait .9;
		p7_platform2 movey(184,1.5);
		p7_platform5 movey(-184,1.5);
		wait .9;
		p7_platform3 movey(184,1.5);
		p7_platform1 movey(-184,1.5);
		wait .9;
		p7_platform4 movey(184,1.5);
		p7_platform2 movey(-184,1.5);
		wait .9;
		p7_platform5 movey(184,1.5);
		p7_platform3 movey(-184,1.5);
		wait .9;
	}
}

part7_spinners()
{
	getent("p7_spinner2","targetname") rotatepitch(45,.1);
	wait .2;
	getent("p7_spinner1","targetname") rotatepitch(-1800000,40000);
	getent("p7_spinner2","targetname") rotatepitch(-1800000,40000);
	getent("p7_spinner3","targetname") rotatepitch(-1800000,40000);
	p7_firering=getent("p7_firering","targetname");
	for(;;) 
	{
		p7_firering rotateto(p7_firering.angles+(0,75,175),1);
		wait 1;
	}
}

part7_booktrig()
{
	p7_bookm = getent("p7_bookm","targetname");
	p7_booktrig = getent("p7_booktrig","targetname");
	for(;;)
	{ 
		wait .05;
		p7_booktrig waittill("trigger",user);
		if(user.book_tmp || user.book) continue;
		user playlocalsound("pickup");
		p7_bookm hide();
		user.book_tmp=true;
		user iprintlnbold("^3Obtained The Book of All Knowledge!");
		wait 2;
		p7_bookm show();
	}
}

part8_lasers()
{
	getent("p8_lasers1","targetname") rotateyaw(-1440000,40000);
	getent("p8_lasers2","targetname") rotateyaw(1440000,40000);
}

part8_hack()
{
	p8_hacktrig=getent("p8_hacktrig","targetname");
	for(;;)
	{
		p8_hacktrig waittill("trigger",user);
		if(!user.hackspeech)
		{
			user.hackspeech=true;
			user iprintln("^4Omnius^7: ^3Good luck with the next jump...I made it Virtually Impossible!");
			wait 2;
			user iprintln(user.name + "^7: ^3Very funny, I will not give up even if I have to jump for eternity!");
			wait 2;
			user iprintln("^4Omnius^7: ^3Bzzztt...hacking detected! Initiating protocoll Mt1337.");
			wait 2;
			user iprintln("^1Commander^7: "+user.name +" ^3, we received a huge interference not long ago, and knew it can't be good.");
			wait 2;
			user iprintln("^1Commander^7: ^3So we started to hack this thing, the jump is possible now.");
			wait 2;
			user iprintln(user.name + "^7: ^3For once I thank you, ^1Commander^3!");
			wait 2;
			user iprintln("^4Omnius^7: ^3Protocoll Mt1337 online! Self destruct initiated!");
			wait 2;
			user iprintln(user.name + "^7: ^3That can't be good...");
		}
	}
}

part9_boss()
{
	p9_crouchlasers=getent("p9_crouchlasers","targetname");
	p9_jumplaser=getent("p9_jumplaser","targetname");
	p9_jumplaser2=getent("p9_jumplaser2","targetname");
	p9_sinkers=getent("p9_sinkers","targetname");
	o=getent("p9_voiceorigin","targetname");
	p9_crouchlasers movex(-1500,.05);
	wait 1;
	for(;;)
	{
		attack=randomint(11);
		switch(attack)
		{
			case 0:
			case 1:
			case 2:
				o playsound("bossattack1");
				wait 1.5;
				p9_sinkers movez(-192,1.5);
				wait 2;
				p9_sinkers movez(192,1);
				wait 4.5;
				break;
			case 3:
			case 4:
				o playsound("bossattack2");
				wait 1.5;
				p9_crouchlasers movex(1500,.05);
				wait .05;
				p9_crouchlasers show();
				wait 1.4;
				p9_crouchlasers movex(-1500,.05);
				wait .05;
				p9_crouchlasers hide();
				wait 5;				
				break;
			case 5:
			case 6:
				o playsound("bossattack3");
				wait 1.5;
				p9_jumplaser movey(6600,10);
				wait 10.2;
				p9_jumplaser movez(-220,.05);
				wait .1;
				p9_jumplaser movey(-6600,.05);
				wait .1;
				p9_jumplaser movez(220,.05);
				wait .1;
				break;
			case 7:
			case 8:
				o playsound("bossattack4");
				wait 1.5;
				p9_jumplaser2 movex(-1580,2.4);
				wait 2.5;
				p9_jumplaser2 movex(1580,2.4);
				wait 5;
				break;
			case 9:
			case 10:
				o playsound("bossattack5");
				wait 1;
				earthquake(3,3,o.origin-(0,3200,2300),3400);
				wait 7;
				break;
		}
	}
}

part9_lasers()
{
	getent("p9_spinlasers","targetname") rotateyaw(1440000,40000);
}

bonus_musictrig()
{
	b_musictrig=getent("bonus_musictrig","targetname");
	m=0;
	for(;;)
	{
		b_musictrig waittill("trigger",user);
		user thread music(m);
		m++;
		if(m==11) m=0;
	}
}

bonus_restart()
{
	b_restart=getent("bonus_teleportrestart","targetname");
	for(;;)
	{
		b_restart waittill("trigger",user1);
		b_restart waittill("trigger",user2);
		if(user1!=user2) continue;
		user2 iprintlnbold("^3RESTARTING MAP!");
		user2 resetplayer();
		user2 suicide();
	}
}

bonus_endlessfun()
{
	b_endlesstele=getent("bonus_endlesstele","targetname");
	b_endlessteleo=getent("bonus_endlesso","targetname");
	for(;;)
	{
		b_endlesstele waittill("trigger",user);
		user setorigin(b_endlessteleo.origin);
	}
}

part6_spinners()
{
	getent("p6_tumbler1","targetname") rotateroll(-900000,40000);
	getent("p6_tumbler2","targetname") rotateroll(-1200000,40000);
	getent("p6_middlespinner","targetname") rotateroll(1800000,40000);
}


part8_gems()
{
	p8_gems=getentarray("p8_gem","targetname");
	p8_gemtrigs=getentarray("p8_gemtrig","targetname");
	for(i=0;i<p8_gems.size;i++) thread part8_gem(p8_gems[i],p8_gemtrigs[i],i);
}

part8_gem(gem,trig,num)
{
	gem hide();
	for(;;)
	{
		trig waittill("trigger",user);
		if(user.gems[num]) continue;
		user playlocalsound("putin");
		gem showtoplayer(user);
		user.gems[num]=true;
		c=0;
		for(i=0;i<6;i++) if(!user.gems[i]) c++;
		if(c==0) {user iprintlnbold("^3Good job!");user suicide();wait 2;user thread music(8);} else
		user iprintlnbold("^3"+c+" more to go!");
	}
}

part8_lift()
{
	p8_lifttrig=getent("p8_lifttrig","targetname");
	for(;;)
	{
		p8_lifttrig waittill("trigger",user);
		for(i=0;i<6;i++) if(!user.gems[i]) break;
		if(i!=6) continue;
		user setorigin(getbrushmodelcenter(p8_lifttrig)-(0,10,60));
		lift=spawn("script_origin",user.origin);
		user linkto(lift);
		lift movez(125,1.5);
		wait 1.6;
		user unlink();
		lift delete();
	}
}