/*  Global scripts for jm_virtual  */
/* Map and script by <MasterThomy> */

init()
{
	maps\mp\_load::main();
	precacheshader("white");
	precacheitem("kar98k_sniper_mp2");
	precacheitem("tt30_mp2");
	
	level.entertexts=[];
	level.entertexts[0]=&"^1Prologue";
	level.entertexts[1]=&"^1Part I";
	level.entertexts[2]=&"^1Part II";
	level.entertexts[3]=&"^1Part III";
	level.entertexts[4]=&"^1Part IV";
	level.entertexts[5]=&"^1Part V";
	level.entertexts[6]=&"^1Part VI";
	level.entertexts[7]=&"^1Part VII";
	level.entertexts[8]=&"^1Part VIII";
	level.entertexts[9]=&"^1Part IX";
	level.entertexts[10]=&"^1Epilogue";
	level.entertexts2=[];
	level.entertexts2[0]=&"^3The Artifact";
	level.entertexts2[1]=&"^3The Lava Lake";
	level.entertexts2[2]=&"^3Test Chambers";
	level.entertexts2[3]=&"^3Travel of Doom";
	level.entertexts2[4]=&"^3A Slippery Encounter";
	level.entertexts2[5]=&"^3The Great Divide";
	level.entertexts2[6]=&"^3Ladder Overkill";
	level.entertexts2[7]=&"^3The Book of All Knowledge";
	level.entertexts2[8]=&"^3A Final Climb";
	level.entertexts2[9]=&"^3Boss Fight!";
	level.entertexts2[10]=&"^3Bonus!";
	for(i=0;i<11;i++) 
	{
		precachestring(level.entertexts[i]);
		precachestring(level.entertexts2[i]);
	}
	precachestring(&"^5Oxygen tank depletes in:");
	precachestring(&"         ^1Congratulations!\n^1You've finished ^2jm_virtual^1!");
	
	level.oldcallbackPlayerConnect=level.callbackPlayerConnect;
	level.callbackPlayerConnect=::playerconnecthook;
	thread teleports();
	thread checkpoints();
	thread secrets();
	thread checkkill();
}

playerconnecthook()
{
	self [[level.oldcallbackPlayerConnect]]();
	
	self resetplayer();
	self.secrets=[];
	for(i=0;i<9;i++) self.secrets[i]=false;
	
	self thread nosave();
	self thread waittillspawn();
}

resetplayer()
{
	self notify("virtual_nodrown");
	self notify("virtual_endfinishtele");
	if(isdefined(self.oxygentext)) self.oxygentext destroy();
	if(isdefined(self.oxygentimer)) self.oxygentimer destroy();
	
	self.reseted=true;
	self.checkptime=0;
	self.checkpo=undefined;
	self.checkpa=undefined;
	self.card1_tmp=false;
	self.card2_tmp=false;
	self.card3_tmp=false;
	self.card1=false;
	self.card2=false;
	self.card3=false;
	self.flipped=false;
	self.scuba_tmp=false;
	self.scuba=false;
	self.book_tmp=false;
	self.book=false;
	self.hackspeech=false;
	self.gems=[];
	for(i=0;i<6;i++) self.gems[i]=false;
	self thread music(0);
	
	p8_gems=getentarray("p8_gem","targetname");
	for(i=0;i<6;i++) p8_gems[i] hide();
	players=getentarray("player","classname");
	for(j=0;j<players.size;j++)
		for(i=0;i<6;i++) 
			if(players[j].gems[i]) p8_gems[i] showtoplayer(players[j]);
}

waittillspawn()
{
	self waittill("spawned_player");
	self freezecontrols(true);
	
	if(!isdefined(self.loads))
	{
		self takeallweapons();
		self setWeaponSlotWeapon("primary", "kar98k_sniper_mp2");
		self giveMaxAmmo("kar98k_sniper_mp2");
		self setWeaponSlotWeapon("primaryb", "tt30_mp2");
		self giveMaxAmmo("tt30_mp2");
		self setspawnweapon("tt30_mp2");
	}
	
	self.blind = newClientHudElem(self);
	self.blind.x = 0;
	self.blind.y = 0;
	self.blind setshader("white", 640, 480);
	self.blind.alignX = "left";
	self.blind.alignY = "top";
	self.blind.horzAlign = "fullscreen";
	self.blind.vertAlign = "fullscreen";
	self.blind.color = (0, 0, 0);
	self.blind.alpha = 1;
	self.partentertext = newClientHudElem(self);
	self.partentertext.x = 320;
	self.partentertext.y = 350;
	self.partentertext.fontscale=2;
	self.partentertext.alignX = "center";
	self.partentertext.alignY = "bottom";
	self.partentertext.horzAlign = "fullscreen";
	self.partentertext.vertAlign = "fullscreen";
	self.partentertext settext(level.entertexts[0]);
	self.partentertext.alpha = 0;
	self.partentertext fadeovertime(1);
	self.partentertext.alpha = 1;
	wait 1.25;
	self.partentertext2 = newClientHudElem(self);
	self.partentertext2.x = 320;
	self.partentertext2.y = 380;
	self.partentertext2.fontscale=2;
	self.partentertext2.alignX = "center";
	self.partentertext2.alignY = "bottom";
	self.partentertext2.horzAlign = "fullscreen";
	self.partentertext2.vertAlign = "fullscreen";
	self.partentertext2 settext(level.entertexts2[0]);
	self.partentertext2.alpha = 0;
	self.partentertext2 fadeovertime(1);
	self.partentertext2.alpha = 1;		
	wait 1.25;
	self.blind fadeovertime(.4);
	self.blind.alpha = 0;
	self.partentertext fadeovertime(.4);
	self.partentertext.alpha = 0;
	self.partentertext2 fadeovertime(.4);
	self.partentertext2.alpha = 0;
	self freezecontrols(false);
	wait .5;
	self.blind destroy();
	self.partentertext destroy();
	self.partentertext2 destroy();
	self iprintln("^1Commander^7: ^3Welcome back, ^7"+self.name+"^3!");
	wait 2;
	self iprintln("^1Commander^7: ^3Good job getting the core, now open the artifact with it!");
	wait 2;
	self iprintln("^1Commander^7: ^3We got to figure out what it is.");
}

checkpoints()
{
	cps=getentarray("checkpoint","targetname");
	for(i=0;i<cps.size;i++) cps[i] thread checkp(i);
}

checkp(id)
{
	for(;;)
	{
		self waittill("trigger",user);
		if(id==12 || id==13) user thread part5_drown();
		if(gettime()-user.checkptime>8000)
		{
			if(user.card1_tmp) {user.card1=true;user.card1_tmp=false;}
			if(user.card2_tmp) {user.card2=true;user.card2_tmp=false;}
			if(user.card3_tmp) {user.card3=true;user.card3_tmp=false;}
			if(user.scuba_tmp) {user.scuba=true;user.scuba_tmp=false;}
			if(user.book_tmp) {user.book=true;user.book_tmp=false;}					
			user.checkptime=gettime();
			user.checkpo=getbrushmodelcenter(self)-(0,0,46);
			if(id!=31) {user.checkpa=(0,user.angles[1],0);if(user getplayerangles()[2]!=0) user setplayerangles((0,user.angles[1],0));}
			if(id==31) user.checkpa=(0,user.angles[1],180);
			user iprintlnbold("^2Checkpoint Saved");
			if(isdefined(user.saves)) {user.saves++;if(isdefined(user.hud_saves)) user.hud_saves setValue(user.saves);} //PJ compatibility
			user.cpload = newClientHudElem(user);
			user.cpload.x = 0;
			user.cpload.y = 0;
			user.cpload setshader("white", 640, 480);
			user.cpload.alignX = "left";
			user.cpload.alignY = "top";
			user.cpload.horzAlign = "fullscreen";
			user.cpload.vertAlign = "fullscreen";
			user.cpload.color = (1, 1, 1);
			user.cpload.alpha = 0;
			user.cpload fadeovertime(.05);
			user.cpload.alpha = 0.25;
			wait .1;
			user.cpload fadeovertime(.05);
			user.cpload.alpha = 0;
			wait .1;
			user.cpload destroy();
		}
		wait 0.05;
	}
}

nosave()
{
	for(;;)
	{
		self waittill("spawned_player");
		if(!isdefined(self.reseted)) self resetplayer(); 
		self notify("end_saveposition_threads");
		if(!isdefined(self.checkpo) || self.pers["team"]=="spectator") continue;
		if(self.card1_tmp) {self.card1_tmp=false;self iprintlnbold("^3Keycard lost!");}
		if(self.card2_tmp) {self.card2_tmp=false;self iprintlnbold("^3Keycard lost!");}
		if(self.card3_tmp) {self.card3_tmp=false;self iprintlnbold("^3Keycard lost!");}
		if(self.scuba_tmp) {self.scuba_tmp=false;self iprintlnbold("^3Scuba gear lost!");}
		if(self.book_tmp) {self.book_tmp=false;self iprintlnbold("^3Book lost!");}
		self.cpload = newClientHudElem(self);
		self.cpload.x = 0;
		self.cpload.y = 0;
		self.cpload setshader("white", 640, 480);
		self.cpload.alignX = "left";
		self.cpload.alignY = "top";
		self.cpload.horzAlign = "fullscreen";
		self.cpload.vertAlign = "fullscreen";
		self.cpload.color = (0, 0, 0);
		self.cpload.alpha = 1;
		self.checkptime=gettime();
		self setorigin(self.checkpo);
		self setplayerangles(self.checkpa);
		self.cpload fadeovertime(.7);
		self.cpload.alpha = 0;
		if(!isdefined(self.loads))
		{
			self takeallweapons();
			self setWeaponSlotWeapon("primary", "kar98k_sniper_mp2");
			self giveMaxAmmo("kar98k_sniper_mp2");
			self setWeaponSlotWeapon("primaryb", "tt30_mp2");
			self giveMaxAmmo("tt30_mp2");
			self setspawnweapon("tt30_mp2");
		} else {self.loads++;if(isdefined(self.hud_loads)) self.hud_loads setValue(self.loads);} //PJ compatibility
		wait .75;
		self.cpload destroy();
	}
}

music(m)
{
	self endon("disconnect");
	self notify("endmusic");
	self endon("endmusic");
	for(;;)
	{		
		self playlocalsound("M"+m);
		switch(m)
		{
			case 0: wait 75.8;break;
			case 1: wait 33.8;break;
			case 2: wait 15.2;break;
			case 3: wait 22.1;break;
			case 4: wait 18.8;break;
			case 5: wait 66;break;
			case 6: wait 27.4;break;
			case 7: wait 17.5;break;
			case 8: wait 42.8;break;
			case 9: wait 41.2;break;
			case 10: wait 44;break;
		}
	}
}

teleports()
{
	thread teleport("p0_teleport",1,1,"Where the hell am I???");
	thread teleport("p1_teleport",2,2,"I feel really stupid just jumping down dark holes like this...");
	thread teleport("p2_teleport",3,3,"Hah, after passing those tests, I feel nothing can stop me!");
	thread teleport("p3_teleport",4,4,"I sense I'll come across some awesome things here...");
	thread teleport("p4_teleport",5,0,"It's nice to see some water after all that f**king lava...");
	thread teleport("p5_teleport",6,6,"Ladder overkill...");
	thread teleport("p6_teleport",7,7,"This place looks like it has something important in it...");
	thread teleport("p7_teleport",8,8,"...");
	thread teleport("p8_teleport",9,9,"I WILL shut you down, ^4Omnius^3!!!");
	thread teleport("p9_teleport",10,0,"Yay, bonus! :)");
	thread teleport2("bonus_teleport1",1);
	thread teleport2("bonus_teleport2",2);
	thread teleport2("bonus_teleport3",3);
	thread teleport2("bonus_teleport4",4);
	thread teleport2("bonus_teleport5",0);
	thread teleport2("bonus_teleport6",6);
	thread teleport2("bonus_teleport7",7);
	thread teleport2("bonus_teleport8",8);
	thread teleport2("bonus_teleport9",9);
	thread teleport2("bonus_teleportd1",6,1);
	thread teleport2("bonus_teleportd2",0,2);
	thread teleport2("bonus_teleportspec",0);
	thread teleport2("bonus_teleportbonus",10);
	thread slidetele();
}

teleport(t,text,music,comment)
{
	tele = getent(t,"targetname");
	teletarget = getent(tele.target,"targetname");
	rings = getent("p7_teleportrings","targetname");
	bookm = getent("p7_book2m","targetname");
	if(text==8)
	{
		bookm hide();
		rings hide();
	}
	for(;;)
	{
		tele waittill("trigger",user);
		if(text==3 && ((!user.card1 && !user.card1_tmp) || (!user.card2 && !user.card2_tmp) || (!user.card3 && !user.card3_tmp))) {user iprintln(user.name + "^7: ^3I think I need to do all three tests first.");continue;}
		if(text==8)
		{
			if(!user.book && !user.book_tmp) {user iprintln(user.name + "^7: ^3I need to get that book in the middle of the room first.");continue;}
			bookm show();
			user setorigin(rings.origin-(0,0,190));
			user linkto(bookm);
			earthquake(1.5,2,user.origin,80);
			wait .5;
			user iprintln(user.name + "^7: ^3What the...");
			rings show();
			rings rotateyaw(540,2);
			rings movez(-120,.5);
			wait 1;
			user thread longspeech();
		}
		if(text==9)
		{
			user iprintln("^4Omnius^7: ^3NO! Now I shall deal with you myself!");
		}
		if(text==10)
		{
			earthquake(2.5,2,user.origin,200);
			user iprintln("^4Omnius^7: ^3NOOOOOOOOOOOOOOOOOOOOOOO!!!");
			wait 1;
			user iprintln("^1Commander^7: ^3Good job, ^7"+user.name+"^3!");
			wait 1;
			user notify("endmusic");
			user playlocalsound("musicofffff");
			user playlocalsound("shutdown");
		}
		if(isdefined(user.blind)) user.blind destroy();
		user.blind = newClientHudElem(user);
		user.blind.x = 0;
		user.blind.y = 0;
		user.blind setshader("white", 640, 480);
		user.blind.alignX = "left";
		user.blind.alignY = "top";
		user.blind.horzAlign = "fullscreen";
		user.blind.vertAlign = "fullscreen";
		user.blind.color = (0, 0, 0);
		user.blind.alpha = 0;
		user.blind fadeovertime(.4);
		user.blind.alpha = 1;
		wait .6;
		if(text==8)
		{
			bookm hide();
			rings hide();
			rings movez(120,1);
			user unlink();
		}
		user setorigin(teletarget.origin+(0,0,.125));
		user setplayerangles(teletarget.angles);
		user linkto(teletarget);
		if(text==10)
		{
			wait .5;
			user.partentertext = newClientHudElem(user);
			user.partentertext.x = 320;
			user.partentertext.y = 200;
			user.partentertext.fontscale=2;
			user.partentertext.alignX = "center";
			user.partentertext.alignY = "bottom";
			user.partentertext.horzAlign = "fullscreen";
			user.partentertext.vertAlign = "fullscreen";
			user.partentertext settext(&"         ^1Congratulations!\n^1You've finished ^2jm_virtual^1!");
			user.partentertext.alpha = 0;
			user.partentertext fadeovertime(1.5);
			user.partentertext.alpha = 1;
			wait 2.5;
			user.partentertext fadeovertime(1.5);
			user.partentertext.alpha = 0;
			wait 1.55;
			user.partentertext destroy();
			wait .5;
			user thread finish();
		}
		user thread music(music);
		user.checkpo=user.origin;
		user.checkpa=user.angles;
		if(user.card1_tmp) {user.card1=true;user.card1_tmp=false;}
		if(user.card2_tmp) {user.card2=true;user.card2_tmp=false;}
		if(user.card3_tmp) {user.card3=true;user.card3_tmp=false;}
		if(user.scuba_tmp) {user.scuba=true;user.scuba_tmp=false;}
		if(user.book_tmp) {user.book=true;user.book_tmp=false;}
		if(user.flipped) {user setplayerangles((0,user.angles[1],0));user.flipped=false;}
		user.partentertext = newClientHudElem(user);
		user.partentertext.x = 320;
		user.partentertext.y = 350;
		user.partentertext.fontscale=2;
		user.partentertext.alignX = "center";
		user.partentertext.alignY = "bottom";
		user.partentertext.horzAlign = "fullscreen";
		user.partentertext.vertAlign = "fullscreen";
		user.partentertext settext(level.entertexts[text]);
		user.partentertext.alpha = 0;
		user.partentertext fadeovertime(1);
		user.partentertext.alpha = 1;
		wait 1.25;
		user.partentertext2 = newClientHudElem(user);
		user.partentertext2.x = 320;
		user.partentertext2.y = 380;
		user.partentertext2.fontscale=2;
		user.partentertext2.alignX = "center";
		user.partentertext2.alignY = "bottom";
		user.partentertext2.horzAlign = "fullscreen";
		user.partentertext2.vertAlign = "fullscreen";
		user.partentertext2 settext(level.entertexts2[text]);
		user.partentertext2.alpha = 0;
		user.partentertext2 fadeovertime(1);
		user.partentertext2.alpha = 1;		
		wait 1.25;
		user.blind fadeovertime(.4);
		user.blind.alpha = 0;
		user.partentertext fadeovertime(.4);
		user.partentertext.alpha = 0;
		user.partentertext2 fadeovertime(.4);
		user.partentertext2.alpha = 0;
		user unlink();
		wait .5;
		user.blind destroy();
		user.partentertext destroy();
		user.partentertext2 destroy();
		wait .5;
		user iprintln(user.name+ "^7: ^3" + comment);
	}
}

teleport2(t,music,text)
{
	tele = getent(t,"targetname");
	teletarget = getent(tele.target,"targetname");
	for(;;)
	{
		tele waittill("trigger",user);
		if(music==10)
		{
			for(i=0;i<9;i++) if(!user.secrets[i]) break;
			if(i!=9) {user iprintlnbold("^3You have to find all 9 secrets to enter the MegaBonus area!\nHint: There is a secret hidden in all 9 main parts.");continue;}
		}
		user.blind = newClientHudElem(user);
		user.blind.x = 0;
		user.blind.y = 0;
		user.blind setshader("white", 640, 480);
		user.blind.alignX = "left";
		user.blind.alignY = "top";
		user.blind.horzAlign = "fullscreen";
		user.blind.vertAlign = "fullscreen";
		user.blind.color = (0, 0, 0);
		user.blind.alpha = 0;
		user.blind fadeovertime(.4);
		user.blind.alpha = 1;
		wait .5;
		user setorigin(teletarget.origin+(0,0,.125));
		user setplayerangles(teletarget.angles);
		user linkto(teletarget);
		user thread music(music);
		user playlocalsound("teleport");
		user.checkpo=user.origin;
		user.checkpa=user.angles;
		if(user.card1_tmp) {user.card1=true;user.card1_tmp=false;}
		if(user.card2_tmp) {user.card2=true;user.card2_tmp=false;}
		if(user.card3_tmp) {user.card3=true;user.card3_tmp=false;}
		if(user.scuba_tmp) {user.scuba=true;user.scuba_tmp=false;}
		if(user.book_tmp) {user.book=true;user.book_tmp=false;}
		if(user.flipped) {user setplayerangles((0,user.angles[1],0));user.flipped=false;}
		user.blind fadeovertime(.4);
		user.blind.alpha = 0;
		user unlink();
		wait .5;
		user.blind destroy();
		if(music==10)
		{
			user iprintlnbold("^3Welcome to ^2<^0MasterThomy^2>^3's waterslide park!\nEnjoy your stay ^^");
			iprintln(user.name + "^3 has entered the Mega-Bonus area!");
		}
		if(isdefined(text) && text==1) user iprintlnbold("^5This was originally part VI, named ^3The Tumbler^5.\n^5It was only wasting time and bugged like hell.");
		if(isdefined(text) && text==2) 
		{
			user iprintlnbold("^5This was originally the start of part VIII.\n^5It was only for the long speech, and was pretty useless.\n^5Enjoy that long speech btw. xD");
			user thread oldlongspeech();
		}
	}
}

slidetele()
{
	tele = getent("bonus_slidetele","targetname");
	teletarget = getent("bonus_bonuso","targetname");
	for(;;)
	{
		tele waittill("trigger",user);
		user.blind = newClientHudElem(user);
		user.blind.x = 0;
		user.blind.y = 0;
		user.blind setshader("white", 640, 480);
		user.blind.alignX = "left";
		user.blind.alignY = "top";
		user.blind.horzAlign = "fullscreen";
		user.blind.vertAlign = "fullscreen";
		user.blind.color = (0, 0, 0);
		user.blind.alpha = 0;
		user.blind fadeovertime(.4);
		user.blind.alpha = 1;
		wait .5;
		user setorigin(teletarget.origin+(0,0,.125));
		user setplayerangles(teletarget.angles);
		user linkto(teletarget);
		user playlocalsound("teleport");
		user.blind fadeovertime(.4);
		user.blind.alpha = 0;
		user unlink();
		wait .5;
		user.blind destroy();
	}
}

checkkill()
{
	lava=getent("lava","targetname");
	kts=getentarray("trigger_hurt","classname");
	for(i=0;i<kts.size;i++) kts[i] setcontents(1);
	plasers=getentarray("script_brushmodel","classname");
	lasers=[];
	for(i=0;i<plasers.size;i++) if(isdefined(plasers[i].script_noteworthy) && plasers[i].script_noteworthy=="laser") lasers[lasers.size]=plasers[i];
	for(;;)	
	{
		players=getentarray("player","classname");
		for(j=0;j<players.size;j++)
		{
			for(i=0;i<lasers.size;i++)
				if(isalive(players[j]) && players[j] istouching(lasers[i])) {players[j] playlocalsound("laserdeath");players[j] suicide();}
			if(isalive(players[j]) && players[j] istouching(lava)) {players[j] playlocalsound("lavadeath");players[j] suicide();}
		}
		wait .05;
	}
}

part5_drown()
{
	self endon("disconnect");
	self notify("virtual_nodrown");
	self endon("virtual_nodrown");
	
	if(isdefined(self.oxygentext)) self.oxygentext destroy();
	if(isdefined(self.oxygentimer)) self.oxygentimer destroy();
	self.oxygentext = newClientHudElem(self);
	self.oxygentext.x = 320;
	self.oxygentext.y = 5;
	self.oxygentext.alignX = "center";
	self.oxygentext.alignY = "top";
	self.oxygentext.horzAlign = "fullscreen";
	self.oxygentext.vertAlign = "fullscreen";
	self.oxygentext settext(&"^5Oxygen tank depletes in:");

	self.oxygentimer = newClientHudElem(self);
	self.oxygentimer.x = 320;
	self.oxygentimer.y = 20;
	self.oxygentimer.alignX = "center";
	self.oxygentimer.alignY = "top";
	self.oxygentimer.horzAlign = "fullscreen";
	self.oxygentimer.vertAlign = "fullscreen";
	self.oxygentimer.color = (0, 1, 1);
	self.oxygentimer.fontscale=1.5;
	self.oxygentimer setTimer(39);
	for(i=0;i<39;i++)
	{
		wait 1;
		if(isdefined(self.oxygentimer)) self.oxygentimer.color=(i/38,1-(i/38),1-(i/38));
	}
	if(isalive(self)) 
	{
		self playlocalsound("lavadeath");
		self suicide();
	}
}

secrets()
{
	trigs=getentarray("secrettrig","targetname");
	models=getentarray("secretm","targetname");
	for(i=0;i<trigs.size;i++) thread secret(trigs[i],models[i],i);
}

secret(trig,model,num)
{
	model rotateyaw(7200000,40000);
	for(;;)
	{
		trig waittill("trigger",user);
		if(user.secrets[num]) continue;
		user.secrets[num]=true;
		model hide();
		c=0;
		for(i=0;i<9;i++) if(user.secrets[i]) c++;
		if(c==9) 
			user iprintlnbold("^5Nice, you found all the secrets!\nNow find the secret entrance!"); 
		else
			user iprintlnbold("^5"+c+"/9 secrets found!");
		wait 5;
		model show();
	}
}

finish()
{
	self endon("disconnect");
	self endon("virtual_endfinishtele");
	wait 4;
	self iprintlnbold("^3You can come back to the finish any time by holding down the Melee key for a few seconds.");
	teletarget=getent("p9_teleporto","targetname");
	for(;;)
	{
		c=0;
		while(self meleebuttonpressed()) {c++;if(c==20) break;wait .1;}
		if(c==20)
		{
			self notify("virtual_nodrown");
			if(isdefined(self.oxygentext)) self.oxygentext destroy();
			if(isdefined(self.oxygentimer)) self.oxygentimer destroy();
			if(isdefined(self.blind)) self.blind destroy();
			self.blind = newClientHudElem(self);
			self.blind.x = 0;
			self.blind.y = 0;
			self.blind setshader("white", 640, 480);
			self.blind.alignX = "left";
			self.blind.alignY = "top";
			self.blind.horzAlign = "fullscreen";
			self.blind.vertAlign = "fullscreen";
			self.blind.color = (0, 0, 0);
			self.blind.alpha = 0;
			self.blind fadeovertime(.5);
			self.blind.alpha = 1;
			wait .6;
			self setorigin(teletarget.origin+(0,0,.125));
			self setplayerangles(teletarget.angles);
			self linkto(teletarget);
			self thread music(0);
			self.blind fadeovertime(.5);
			self.blind.alpha = 0;
			self unlink();
			wait .6;
			self.blind destroy();
		}
		wait .5;
	}
}

longspeech()
{
	wait 4.5;
	self iprintln(self.name + "^7: ^3What the hell just happened?");
	wait 2.5;
	self iprintln("^4Voice in your head^7: ^3Congratulations, you have been proven worthy...");
	wait 2.5;
	self iprintln(self.name + "^7: ^3Woot, cool!");
	wait 2.5;
	self iprintln("^4Voice in your head^7: ^3...worthy for your soul to be absorbed by me. I am ^4Omnius^3!");
	wait 2.5;
	self iprintln(self.name + "^7: ^3Wait, what?!");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3Yes, this virtual reality was designed to find skilled jumpers like you.");
	wait 2.5;
	self iprintln(self.name + "^7: ^3You say this is not even real?");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3Your absorbsion will be very real, and it'll serve a higher purpose!");
	wait 2.5;
	self iprintln(self.name + "^7: ^3But I don't want to be absorbed!!!");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3It's not your choice, the second you give up hope your soul is mine.");
	wait 2.5;
	self iprintln(self.name + "^7: ^3I WILL NEVER GIVE UP!");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3Good luck then...you'll need it.");
}

oldlongspeech()
{
	wait 4.5;
	self iprintln(self.name + "^7: ^3What the hell just happened?");
	wait 2.5;
	self iprintln("^4Voice in your head^7: ^3You passed the test.");
	wait 2.5;
	self iprintln(self.name + "^7: ^3Huh..? I think I'm going insane here.");
	wait 2.5;
	self iprintln("^4Voice in your head^7: ^3No you're not. This is ALL in your head.");
	wait 2.5;
	self iprintln(self.name + "^7: ^3You mean nothing here is real?");
	wait 2.5;
	self iprintln("^4Voice in your head^7: ^3Actually it is. I make it real. I'm ^4Omnius^3!");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3This is something you would call a virtual reality.");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3I also created this labyrinth so we canhave some time to communicate.");
	wait 2.5;
	self iprintln(self.name + "^7: ^3I really hate labyrinths...");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3Yes, I know.");
	wait 2.5;
	self iprintln(self.name + "^7: ^3Great...so what test did I pass?");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3This objects purpose was to find skilled souls, and absorb them.");
	wait 2.5;
	self iprintln(self.name + "^7: ^3WHAT?");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3Yes, and you are obviously skilled enough, if you got this far.");
	wait 2.5;
	self iprintln(self.name + "^7: ^3I thought you were a good...but of course, you are evil...");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3Foolish thoughts! This object is to create a greater being!");
	wait 2.5;
	self iprintln(self.name + "^7: ^3That may be true, but I don't want a part in it.");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3It's not your choice, you'll give up sooner or later, and when you do...");
	wait 2.5;
	self iprintln(self.name + "^7: ^3I WILL NEVER GIVE UP!");
	wait 2.5;
	self iprintln("^4Omnius^7: ^3Good luck then...you'll need it.");
	wait 2.5;
	self iprintln(self.name + "^7: ^3I really hope the scientist at the base work fast...");
}